/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealTrackerApp.cpp
**
** DESCRIPTION: This program implements the methods of CRealTrackerApp class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang       March-2001
**
/**************************************************************************/


// RealTracker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "RealTracker.h"

#include "MainFrm.h"
#include "RealTrackerDoc.h"
#include "RealTrackerView.h"
#include "SysStatus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerApp

BEGIN_MESSAGE_MAP(CRealTrackerApp, CWinApp)
	//{{AFX_MSG_MAP(CRealTrackerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerApp construction

CRealTrackerApp::CRealTrackerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRealTrackerApp object

CRealTrackerApp theApp;

CSysStatus theSysStatus;

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerApp initialization

BOOL CRealTrackerApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CRealTrackerDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CRealTrackerView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CRealTrackerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerApp message handlers

// .INI File Section and entries
static const char szAppSection[] = "VideoTestUserOption";
static const char szAppUserName[] = "UserName";
static const char szAppEmailAddr[] = "EmailAddr";
static const char szAppCountry[] = "Country";
static const char szAppState[] = "State";
static const char szAppCPUType[] = "CPUType";
static const char szAppMEMCap[] = "MEMCap";
static const char szAppOSType[] = "OSType";
static const char szAppUserCpu[] = "UserCpu";
static const char szAppNetConfig[] = "NetConfig";
static const char szAppPlayTime[] = "PlayTime";
static const char szAppCheckQuality[] = "CheckQuality";
static const char szAppLogFile[] = "LogFile";


BOOL CRealTrackerApp::IsFirstRun()
{
    UINT nUndefinedDaulft = 999;
    return GetProfileInt(szAppSection, szAppOSType, nUndefinedDaulft) == nUndefinedDaulft;
}

void CRealTrackerApp::GetUserOption(Preference &option)
{
    // Restore previous selections
    option.UserName = GetProfileString(szAppSection, szAppUserName, option.UserName);
    option.EmailAddr = GetProfileString(szAppSection, szAppEmailAddr, option.EmailAddr);
    option.Country = GetProfileString(szAppSection, szAppCountry, option.Country);
    option.State = GetProfileString(szAppSection, szAppState, option.State);
    option.CPUType = GetProfileString(szAppSection, szAppCPUType, option.CPUType);
    option.MEMCap = GetProfileInt(szAppSection, szAppMEMCap, option.MEMCap);
    option.OSType = GetProfileInt(szAppSection, szAppOSType, option.OSType);
    option.UserCpu = GetProfileInt(szAppSection, szAppUserCpu, option.UserCpu);
    option.NetConfig = GetProfileInt(szAppSection, szAppNetConfig, option.NetConfig);
    option.PlayTime = GetProfileInt(szAppSection, szAppPlayTime, option.PlayTime);
    option.CheckQuality = GetProfileInt(szAppSection, szAppCheckQuality, option.CheckQuality);
    option.LogFile = GetProfileString(szAppSection, szAppLogFile, option.LogFile);
}

void CRealTrackerApp::WriteUserOption(const Preference &option)
{
    // Save entries to .ini for next use
    WriteProfileString(szAppSection, szAppUserName, option.UserName);
    WriteProfileString(szAppSection, szAppEmailAddr, option.EmailAddr);
    WriteProfileString(szAppSection, szAppCountry, option.Country);
    WriteProfileString(szAppSection, szAppState, option.State);
    WriteProfileString(szAppSection, szAppCPUType, option.CPUType);
    WriteProfileInt(szAppSection, szAppMEMCap, option.MEMCap);
    WriteProfileInt(szAppSection, szAppOSType, option.OSType);
    WriteProfileInt(szAppSection, szAppUserCpu, option.UserCpu);
    WriteProfileInt(szAppSection, szAppNetConfig, option.NetConfig);
    WriteProfileInt(szAppSection, szAppPlayTime, option.PlayTime);
    WriteProfileInt(szAppSection, szAppCheckQuality, option.CheckQuality);
    WriteProfileString(szAppSection, szAppLogFile, option.LogFile);
}

BYTE CRealTrackerApp::ByteMap(BYTE data)
{
    BYTE bits[8];

    BYTE mask = 1;
    for (int i=0; i<8; i++)
    {
        bits[i] = (data & mask) >> i;
        mask = mask << 1;
    }

    return bits[7] | (bits[6] << 1) | (bits[5] << 2) | (bits[4] << 3) | 
           (bits[3] << 4) | (bits[2] << 5) | (bits[1] << 6) | (bits[0] << 7);
}

void CRealTrackerApp::EncodeWrite(FILE *fp, CString str)
{
    char buf[4096];

    int num = str.GetLength();
    char *p = (char *) &num;
    buf[0] = (char) ByteMap((BYTE)p[3]);
    buf[1] = (char) ByteMap((BYTE)p[2]);
    buf[2] = (char) ByteMap((BYTE)p[1]);
    buf[3] = (char) ByteMap((BYTE)p[0]);
    fwrite(buf, 1, 4, fp);

    if (num > 0)
    {
        buf[0] = (char) ByteMap((BYTE)str[0]);
        for (int i=1; i<num; i++)
            buf[i] = (char) ByteMap(((BYTE)str[i-1]) ^ ((BYTE)str[i]));
        fwrite(buf, 1, num, fp);
    }
}

BOOL CRealTrackerApp::DecodeRead(FILE *fp, CString &str)
{
    char buf[4096];

    if (fread(buf, 1, 4, fp) != 4)
        return FALSE;
    int num;
    char *p = (char *) &num;
    p[0] = (char) ByteMap((BYTE)buf[3]);
    p[1] = (char) ByteMap((BYTE)buf[2]);
    p[2] = (char) ByteMap((BYTE)buf[1]);
    p[3] = (char) ByteMap((BYTE)buf[0]);

    if (num < 0 || num > 4096)
        return FALSE;

    if ((int)fread(buf, 1, num, fp) != num)
        return num;

    if (num > 0)
    {
        buf[0] = (char) ByteMap((BYTE)buf[0]);
        for (int i=1; i<num; i++)
            buf[i] = (char) (ByteMap((BYTE)buf[i]) ^ ((BYTE)buf[i-1]));
    }
    buf[num] = 0;
    str = buf;

    return TRUE;
}

