/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealTracker.h
**
** DESCRIPTION: This class defines the document class for RealTracker
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/



// RealTrackerDoc.h : interface of the CRealTrackerDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_REALTRACKERDOC_H__CC6D764A_FDF3_43D4_BFD1_9267DA95B6FE__INCLUDED_)
#define AFX_REALTRACKERDOC_H__CC6D764A_FDF3_43D4_BFD1_9267DA95B6FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Preference.h"

class CRealTrackerDoc : public CDocument
{
protected: // create from serialization only
	CRealTrackerDoc();
	DECLARE_DYNCREATE(CRealTrackerDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealTrackerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRealTrackerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRealTrackerDoc)
	afx_msg void OnFileMakeconfig();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    CStringArray m_ProgDspt;
    CStringArray m_ProgList;

public:
    int GetProgListNum();
    CString GetProgDspt(int index);
    CString GetProgList(int index);

    void WriteAutoMail(FILE *fp, BOOL bAutoMail, CString server, CString name, CString email);
    void WriteAutoFTP(FILE *fp, BOOL bAutoFTP, CString server, CString user, CString passwd, CString dir);

    BOOL ReadAutoConfig(AdvancedPreference &AdvPref);
    BOOL ReadAutoMail(FILE *fp, BOOL &bAutoMail, CString &server, CString &name, CString &email);
    BOOL ReadAutoFTP(FILE *fp, BOOL &bAutoFTP, CString &server, CString &user, CString &passwd, CString &dir);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALTRACKERDOC_H__CC6D764A_FDF3_43D4_BFD1_9267DA95B6FE__INCLUDED_)
