/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: SaveLogDlg.cpp
**
** DESCRIPTION: This program implements the methods of CSaveLogDlg class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang       March-2001
**
/**************************************************************************/


// SaveLogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RealTracker.h"
#include "SaveLogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSaveLogDlg dialog


CSaveLogDlg::CSaveLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSaveLogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSaveLogDlg)
	m_bSaveLog = FALSE;
	m_DirName = _T("");
	//}}AFX_DATA_INIT
}


void CSaveLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSaveLogDlg)
	DDX_Check(pDX, IDC_CHECK_SAVELOG, m_bSaveLog);
	DDX_Text(pDX, IDC_EDIT_DIRNAME, m_DirName);
	DDV_MaxChars(pDX, m_DirName, 256);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSaveLogDlg, CDialog)
	//{{AFX_MSG_MAP(CSaveLogDlg)
	ON_BN_CLICKED(IDC_CHECK_SAVELOG, OnCheckSavelog)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSaveLogDlg message handlers

BOOL CSaveLogDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    if (! m_bSaveLog)
    {
        GetDlgItem(IDC_STATIC_DIRNAME)->EnableWindow(FALSE);
        GetDlgItem(IDC_EDIT_DIRNAME)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON_BROWSE)->EnableWindow(FALSE);
    }
	
	return TRUE;
}

void CSaveLogDlg::OnCheckSavelog() 
{
    m_bSaveLog = ! m_bSaveLog;
    GetDlgItem(IDC_STATIC_DIRNAME)->EnableWindow(m_bSaveLog);
    GetDlgItem(IDC_EDIT_DIRNAME)->EnableWindow(m_bSaveLog);
    GetDlgItem(IDC_BUTTON_BROWSE)->EnableWindow(m_bSaveLog);
}

void CSaveLogDlg::OnButtonBrowse() 
{
    BROWSEINFO bwinfo;          // the structure which contains necessary informations 
    char buffer[MAX_PATH];      // will receive the folder name 
    LPITEMIDLIST itemids=NULL;  // pointer to items list 
    char folder_path[MAX_PATH]; // will receive the folder complete path 
    LPMALLOC shallocator;       // will point to IMalloc interface of shell memory allocator 

    FillMemory((void*)&bwinfo, sizeof(bwinfo), 0);  // memory cleaning 
    bwinfo.hwndOwner = this->m_hWnd;        // handle of owner window (NULL here) 
    bwinfo.pidlRoot = NULL;                 // starting point for browse (NULL means Computer Desktop) 
    bwinfo.pszDisplayName = (char*) buffer; // will receive folder name (as displayed) 
    bwinfo.lpszTitle = "Select a directory to save log files";  // dialog title 
    bwinfo.ulFlags = 0;                     // browsing flags (0 means no restrictions) 
    itemids = SHBrowseForFolder(&bwinfo);   // now browsing for folder...and keep the results 
    if (itemids != NULL)                    // IDOK
    { 
        SHGetPathFromIDList(itemids, (char*)folder_path);   // get the folder path from SHBrowseForFolder result 
        SHGetMalloc(&shallocator);                          // get shell memory allocator (a pointer to his IMalloc interface) 
        shallocator->Free((void*)itemids);                  // releasing memory via this allocator 
        shallocator->Release();                             // releasing allocator 

        m_DirName = folder_path;
        SetDlgItemText(IDC_EDIT_DIRNAME, m_DirName);
    } 
}
