/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealTreeView.h
**
** DESCRIPTION: This class defines the view structure of left window of RealData
**              program;                    
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


#if !defined(AFX_REALTREEVIEW_H__B663C121_3A30_4927_A9F3_1BFCA0931CD7__INCLUDED_)
#define AFX_REALTREEVIEW_H__B663C121_3A30_4927_A9F3_1BFCA0931CD7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RealTreeView.h : header file
//

#include <afxcview.h>

#include "RealDataDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CRealTreeView view

class CRealTreeView : public CTreeView
{
public:
    BOOL m_bInitialUpdated;
    CTreeCtrl *m_pTreeCtrl;
    HTREEITEM m_hPreviousSelectedItem;
    HTREEITEM m_hRootItem;


protected:
	CRealTreeView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CRealTreeView)

// Attributes
public:
    CRealDataDoc* GetDocument();
    void AddItem(int index);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealTreeView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CRealTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CRealTreeView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALTREEVIEW_H__B663C121_3A30_4927_A9F3_1BFCA0931CD7__INCLUDED_)
